#include "msp.h"
#include <stdio.h>
#include <stdint.h>
#include "EventLib.h"


uint16_t	Event_num, ev_irqn, ev_flag;
uint8_t		p5bit = 0, p6ifg;
uint16_t	error_interrupt = 0;

int main(void) {

    WDT_A->CTL = WDT_A_CTL_PW | WDT_A_CTL_HOLD;               // Stop WDT

    /* Step 1: Transition to VCORE Level 1: AM0_LDO --> AM1_LDO */
    PCM->CTL0 = PCM_CTL0_KEY_VAL | PCM_CTL0_AMR_1;
    while ((PCM->CTL1 & PCM_CTL1_PMR_BUSY));
    if ((PCM->CTL0 & PCM_CTL0_CPM_MASK) != PCM_CTL0_CPM_1)    while(1);
    /* Step2 : configure Flash wait, No wait */

    /* Step3 : Configure DCO to 24MHz -> MCLK=24MHz, 1/2->SMCLK=12MHz
     * 			REFO -> ACLK, -> BCLK									 */
    CS->KEY = CS_KEY_VAL ;                  // Unlock CS module
    //CS->CTL0 = 0;                           // Reset tuning parameters
    CS->CTL0 = CS_CTL0_DCORSEL_4;           // Set DCO to 24MHz
    CS->CTL1 = CS_CTL1_SELA_2 | CS_CTL1_SELS_3 | CS_CTL1_SELM_3 |
    			CS_CTL1_SELB | CS_CTL1_DIVS_1 | CS_CTL1_DIVHS_1;
    CS->KEY = 0;                             // Lock CS module

    /* configure Port  */
    P1->DIR |= BIT0 | BIT1;							// P1.0,1 output
    P1->OUT &= ~(BIT0 | BIT1);             			// P1.0 LED off
    // function timings-> P4.2, MCLK -> P4.3
    P4->DIR |= BIT2 | BIT3; P4->SEL0 |= BIT3; P4->SEL1 &= ~ BIT3;

    while(1)
    {
    	P1->OUT |= BIT0;
    	Event_Send( 0, 1 );
    	Event_Send( 15, 2 );
    	Event_Send( 16, 3 );
    	Event_Send( 31, 4 );
    	Event_Send( 32, 5 );
    	Event_Send( 47, 6 );
    	Event_Send( 48, 7 );
    	Event_Send( 63, 8 );
    	P1->OUT &= ~BIT0;
    	
    	while(1)
    	{
    		P4->OUT |= BIT2;						// output timings of vent_Read
    		Event_num = Event_Read( );
    		ev_irqn = (Event_num & 0x00FF);
    		ev_flag = (Event_num >> 8);
    		P4->OUT &= ~BIT2;
    		if( ev_irqn == Event_false)	break;
    		//printf ("IRQ %d flag %x\n", ev_irqn, ev_flag );
    	}
    }
}
